--- vdr-1.3.34-orig/vdr.c	2005-09-24 16:27:26.000000000 +0300
+++ vdr-1.3.34/vdr.c	2005-10-09 12:26:34.000000000 +0300
@@ -155,6 +155,9 @@
       { "rcu",      optional_argument, NULL, 'r' | 0x100 },
       { "record",   required_argument, NULL, 'r' },
       { "shutdown", required_argument, NULL, 's' },
+#if 1
+      { "settime",  required_argument, NULL, 'T' },
+#endif
       { "terminal", required_argument, NULL, 't' },
       { "version",  no_argument,       NULL, 'V' },
       { "vfat",     no_argument,       NULL, 'v' | 0x100 },
@@ -164,7 +167,7 @@
     };
 
   int c;
-  while ((c = getopt_long(argc, argv, "a:c:dD:E:hl:L:mp:P:r:s:t:v:Vw:", long_options, NULL)) != -1) {
+  while ((c = getopt_long(argc, argv, "a:c:dD:E:hl:L:mp:P:r:s:t:T:v:Vw:", long_options, NULL)) != -1) {
         switch (c) {
           case 'a': AudioCommand = optarg;
                     break;
@@ -242,6 +245,10 @@
                     break;
           case 's': Shutdown = optarg;
                     break;
+#if 1
+          case 'T': cEitFilter::SetTimeCommand = strdup(optarg);
+                    break;
+#endif
           case 't': Terminal = optarg;
                     if (access(Terminal, R_OK | W_OK) < 0) {
                        fprintf(stderr, "vdr: can't access terminal: %s\n", Terminal);
@@ -309,6 +316,9 @@
                "  -r CMD,   --record=CMD   call CMD before and after a recording\n"
                "  -s CMD,   --shutdown=CMD call CMD to shutdown the computer\n"
                "  -t TTY,   --terminal=TTY controlling tty\n"
+#if 1
+	       "  -T CMD,   --settime=CMD  call CMD to set system time\n"
+#endif
                "  -v DIR,   --video=DIR    use DIR as video directory (default: %s)\n"
                "  -V,       --version      print version information and exit\n"
                "            --vfat         encode special characters in recording names to\n"
--- vdr-1.3.34-orig/eit.h	2003-12-21 16:51:50.000000000 +0200
+++ vdr-1.3.34/eit.h	2005-10-09 12:22:52.000000000 +0300
@@ -17,6 +17,11 @@
   virtual void Process(u_short Pid, u_char Tid, const u_char *Data, int Length);
 public:
   cEitFilter(void);
+
+#if 1
+  static char *SetTimeCommand;
+#endif
+
   };
 
 #endif //__EIT_H
--- vdr-1.3.34-orig/eit.c	2005-09-04 14:36:30.000000000 +0300
+++ vdr-1.3.34/eit.c	2005-10-09 12:22:52.000000000 +0300
@@ -253,13 +253,13 @@
   static cMutex mutex;
   static int lastDiff;
 public:
-  cTDT(const u_char *Data);
+  cTDT(const u_char *Data, char *SetTimeCommand = NULL);
   };
 
 cMutex cTDT::mutex;
 int cTDT::lastDiff = 0;
 
-cTDT::cTDT(const u_char *Data)
+cTDT::cTDT(const u_char *Data, char *SetTimeCommand)
 :SI::TDT(Data, false)
 {
   CheckParse();
@@ -271,10 +271,29 @@
   if (diff > 2) {
      mutex.Lock();
      if (abs(diff - lastDiff) < 3) {
+
+#if 1 /* PH */
+       if(SetTimeCommand) {
+	 static time_t last = 0;
+	 if(loctim-last > 60) {
+	   isyslog("System Time = %s (%ld)\n", *TimeToString(loctim), loctim);
+	   isyslog("Local Time  = %s (%ld)\n", *TimeToString(sattim), sattim);
+	   char tmp[1024];
+	   sprintf(tmp,"%s %d", SetTimeCommand, (int)sattim);
+	   system(tmp);
+	   last = loctim;
+	 }
+       } else {
+fprintf(stderr,"set system time: NO PROGRAM SET\n");
+#endif
+
         isyslog("System Time = %s (%ld)\n", *TimeToString(loctim), loctim);
         isyslog("Local Time  = %s (%ld)\n", *TimeToString(sattim), sattim);
         if (stime(&sattim) < 0)
            esyslog("ERROR while setting system time: %m");
+#if 1 /* PH */
+        }
+#endif
         }
      lastDiff = diff;
      mutex.Unlock();
@@ -291,6 +310,8 @@
   Set(0x14, 0x70);        // TDT
 }
 
+char *cEitFilter::SetTimeCommand = NULL;
+
 void cEitFilter::Process(u_short Pid, u_char Tid, const u_char *Data, int Length)
 {
   switch (Pid) {
@@ -303,7 +324,7 @@
          break;
     case 0x14: {
          if (Setup.SetSystemTime && Setup.TimeTransponder && ISTRANSPONDER(Transponder(), Setup.TimeTransponder))
-            cTDT TDT(Data);
+            cTDT TDT(Data, SetTimeCommand);
          }
          break;
     }
